Index: /palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3866)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! Use PALM's working precision
+! Improved coding style
+! 
+! 
+! 3785 2019-03-06 10:41:14Z eckhard
 ! Remove basic state pressure before computing geostrophic wind
 !  - Introduced new level-based profile averaging routine that does not rely on
@@ -106,5 +111,5 @@
     USE inifor_control
     USE inifor_defs,                                                           &
-        ONLY: BETA, dp, G, P_SL, PI, RD, T_SL, TO_DEGREES, TO_RADIANS
+        ONLY: BETA, G, P_SL, PI, RD, T_SL, TO_DEGREES, TO_RADIANS, wp
     USE inifor_types
     USE inifor_util,                                                           &
@@ -116,32 +121,32 @@
 
 
-    SUBROUTINE interpolate_1d(in_arr, out_arr, outgrid)
-       TYPE(grid_definition), INTENT(IN) ::  outgrid
-       REAL(dp), INTENT(IN)              ::  in_arr(:)
-       REAL(dp), INTENT(OUT)             ::  out_arr(:)
-
-       INTEGER :: k, l, nz
-
-       nz = UBOUND(out_arr, 1)
-
-       DO k = nz, LBOUND(out_arr, 1), -1
-
-!
-!--       TODO: Remove IF clause and extrapolate based on a critical vertical
-!--       TODO: index marking the lower bound of COSMO-DE data coverage.
-!--       Check for negative interpolation weights indicating grid points 
-!--       below COSMO-DE domain and extrapolate from the top in such cells.
-          IF (outgrid % w(1,k,1) < -1.0_dp .AND. k < nz)  THEN
-             out_arr(k) = out_arr(k+1)
-          ELSE
-             out_arr(k) = 0.0_dp
-             DO l = 1, 2
-                out_arr(k) = out_arr(k) +                                      &
-                    outgrid % w(1,k,l) * in_arr(outgrid % kkk(1,k,l) )
-             ENDDO
-          ENDIF
-       ENDDO
-
-    END SUBROUTINE interpolate_1d
+ SUBROUTINE interpolate_1d(in_arr, out_arr, outgrid)
+    TYPE(grid_definition), INTENT(IN) ::  outgrid
+    REAL(wp), INTENT(IN)              ::  in_arr(:)
+    REAL(wp), INTENT(OUT)             ::  out_arr(:)
+
+    INTEGER :: k, l, nz
+
+    nz = UBOUND(out_arr, 1)
+
+    DO  k = nz, LBOUND(out_arr, 1), -1
+
+!
+!--    TODO: Remove IF clause and extrapolate based on a critical vertical
+!--    TODO: index marking the lower bound of COSMO-DE data coverage.
+!--    Check for negative interpolation weights indicating grid points 
+!--    below COSMO-DE domain and extrapolate from the top in such cells.
+       IF (outgrid%w(1,k,1) < -1.0_wp .AND. k < nz)  THEN
+          out_arr(k) = out_arr(k+1)
+       ELSE
+          out_arr(k) = 0.0_wp
+          DO  l = 1, 2
+             out_arr(k) = out_arr(k) +                                      &
+                 outgrid%w(1,k,l) * in_arr(outgrid%kkk(1,k,l) )
+          ENDDO
+       ENDIF
+    ENDDO
+
+ END SUBROUTINE interpolate_1d
 
 
@@ -158,9 +163,9 @@
 !> invar : Array of source data
 !> 
-!> outgrid % kk : Array of vertical neighbour indices. kk(i,j,k,:) contain the
+!> outgrid%kk : Array of vertical neighbour indices. kk(i,j,k,:) contain the
 !>     indices of the two vertical neighbors of PALM-4U point (i,j,k) on the
 !>     input grid corresponding to the source data invar.
 !> 
-!> outgrid % w_verti : Array of weights for vertical linear interpolation
+!> outgrid%w_verti : Array of weights for vertical linear interpolation
 !>     corresponding to neighbour points indexed by kk.
 !>
@@ -169,36 +174,36 @@
 !> outvar : Array of interpolated data
 !------------------------------------------------------------------------------!
-    SUBROUTINE interpolate_1d_arr(in_arr, out_arr, outgrid)
-       TYPE(grid_definition), INTENT(IN) ::  outgrid
-       REAL(dp), INTENT(IN)              ::  in_arr(0:,0:,0:)
-       REAL(dp), INTENT(OUT)             ::  out_arr(0:,0:,:)
-
-       INTEGER :: i, j, k, l, nz
-
-       nz = UBOUND(out_arr, 3)
-
-       DO j = LBOUND(out_arr, 2), UBOUND(out_arr, 2)
-       DO i = LBOUND(out_arr, 1), UBOUND(out_arr, 1)
-       DO k = nz, LBOUND(out_arr, 3), -1
-
-!
-!--       TODO: Remove IF clause and extrapolate based on a critical vertical
-!--       TODO: index marking the lower bound of COSMO-DE data coverage.
-!--       Check for negative interpolation weights indicating grid points 
-!--       below COSMO-DE domain and extrapolate from the top in such cells.
-          IF (outgrid % w_verti(i,j,k,1) < -1.0_dp .AND. k < nz)  THEN
-             out_arr(i,j,k) = out_arr(i,j,k+1)
-          ELSE
-             out_arr(i,j,k) = 0.0_dp
-             DO l = 1, 2
-                out_arr(i,j,k) = out_arr(i,j,k) +                              &
-                    outgrid % w_verti(i,j,k,l) *                               &
-                    in_arr(i,j,outgrid % kk(i,j,k, l) )
-             ENDDO
-          ENDIF
-       ENDDO
-       ENDDO
-       ENDDO
-    END SUBROUTINE interpolate_1d_arr
+ SUBROUTINE interpolate_1d_arr(in_arr, out_arr, outgrid)
+    TYPE(grid_definition), INTENT(IN) ::  outgrid
+    REAL(wp), INTENT(IN)              ::  in_arr(0:,0:,0:)
+    REAL(wp), INTENT(OUT)             ::  out_arr(0:,0:,:)
+
+    INTEGER :: i, j, k, l, nz
+
+    nz = UBOUND(out_arr, 3)
+
+    DO  j = LBOUND(out_arr, 2), UBOUND(out_arr, 2)
+    DO  i = LBOUND(out_arr, 1), UBOUND(out_arr, 1)
+    DO  k = nz, LBOUND(out_arr, 3), -1
+
+!
+!--    TODO: Remove IF clause and extrapolate based on a critical vertical
+!--    TODO: index marking the lower bound of COSMO-DE data coverage.
+!--    Check for negative interpolation weights indicating grid points 
+!--    below COSMO-DE domain and extrapolate from the top in such cells.
+       IF (outgrid%w_verti(i,j,k,1) < -1.0_wp .AND. k < nz)  THEN
+          out_arr(i,j,k) = out_arr(i,j,k+1)
+       ELSE
+          out_arr(i,j,k) = 0.0_wp
+          DO  l = 1, 2
+             out_arr(i,j,k) = out_arr(i,j,k) +                              &
+                 outgrid%w_verti(i,j,k,l) *                               &
+                 in_arr(i,j,outgrid%kk(i,j,k, l) )
+          ENDDO
+       ENDIF
+    ENDDO
+    ENDDO
+    ENDDO
+ END SUBROUTINE interpolate_1d_arr
 
 
@@ -214,5 +219,5 @@
 !> invar : Array of source data
 !> 
-!> outgrid % ii, % jj : Array of neighbour indices in x and y direction.
+!> outgrid%ii,%jj : Array of neighbour indices in x and y direction.
 !>     ii(i,j,k,:), and jj(i,j,k,:) contain the four horizontal neighbour points
 !>     of PALM-4U point (i,j,k) on the input grid corresponding to the source
@@ -220,5 +225,5 @@
 !      form of the interpolation weights.)
 !> 
-!> outgrid % w_horiz: Array of weights for horizontal bi-linear interpolation
+!> outgrid%w_horiz: Array of weights for horizontal bi-linear interpolation
 !>     corresponding to neighbour points indexed by ii and jj.
 !>
@@ -227,40 +232,40 @@
 !> outvar : Array of interpolated data
 !------------------------------------------------------------------------------!
-    SUBROUTINE interpolate_2d(invar, outvar, outgrid, ncvar)
-!
-!--    I index 0-based for the indices of the outvar to be consistent with the
-!--    outgrid indices and interpolation weights.
-       TYPE(grid_definition), INTENT(IN)  ::  outgrid
-       REAL(dp), INTENT(IN)               ::  invar(0:,0:,0:)
-       REAL(dp), INTENT(OUT)              ::  outvar(0:,0:,0:)
-       TYPE(nc_var), INTENT(IN), OPTIONAL ::  ncvar
-
-       INTEGER ::  i, j, k, l
-
-!
-!--    TODO: check if input dimensions are consistent, i.e. ranges are correct
-       IF ( UBOUND(outvar, 3) .GT. UBOUND(invar, 3) )  THEN
-           message = "Output array for '" // TRIM(ncvar % name) // "' has ' more levels (" // &
-              TRIM(str(UBOUND(outvar, 3))) // ") than input variable ("//&
-              TRIM(str(UBOUND(invar, 3))) // ")."
-           CALL inifor_abort('interpolate_2d', message)
-       ENDIF
-
-       DO k = 0, UBOUND(outvar, 3)
-       DO j = 0, UBOUND(outvar, 2)
-       DO i = 0, UBOUND(outvar, 1)
-          outvar(i,j,k) = 0.0_dp
-          DO l = 1, 4
-             
-             outvar(i,j,k) = outvar(i,j,k) +                                   &
-                outgrid % w_horiz(i,j,l) * invar( outgrid % ii(i,j,l),         & 
-                                                  outgrid % jj(i,j,l),         &
-                                                  k )
-          ENDDO
+ SUBROUTINE interpolate_2d(invar, outvar, outgrid, ncvar)
+!
+!-- I index 0-based for the indices of the outvar to be consistent with the
+!-- outgrid indices and interpolation weights.
+    TYPE(grid_definition), INTENT(IN)  ::  outgrid
+    REAL(wp), INTENT(IN)               ::  invar(0:,0:,0:)
+    REAL(wp), INTENT(OUT)              ::  outvar(0:,0:,0:)
+    TYPE(nc_var), INTENT(IN), OPTIONAL ::  ncvar
+
+    INTEGER ::  i, j, k, l
+
+!
+!-- TODO: check if input dimensions are consistent, i.e. ranges are correct
+    IF ( UBOUND(outvar, 3) .GT. UBOUND(invar, 3) )  THEN
+        message = "Output array for '" // TRIM(ncvar%name) // "' has ' more levels (" // &
+           TRIM(str(UBOUND(outvar, 3))) // ") than input variable ("//&
+           TRIM(str(UBOUND(invar, 3))) // ")."
+        CALL inifor_abort('interpolate_2d', message)
+    ENDIF
+
+    DO  k = 0, UBOUND(outvar, 3)
+    DO  j = 0, UBOUND(outvar, 2)
+    DO  i = 0, UBOUND(outvar, 1)
+       outvar(i,j,k) = 0.0_wp
+       DO  l = 1, 4
+          
+          outvar(i,j,k) = outvar(i,j,k) +                                   &
+             outgrid%w_horiz(i,j,l) * invar( outgrid%ii(i,j,l),         & 
+                                               outgrid%jj(i,j,l),         &
+                                               k )
        ENDDO
-       ENDDO
-       ENDDO
+    ENDDO
+    ENDDO
+    ENDDO
         
-    END SUBROUTINE interpolate_2d
+ END SUBROUTINE interpolate_2d
 
 
@@ -271,40 +276,40 @@
 !> out_arr(:)
 !------------------------------------------------------------------------------!
-    SUBROUTINE average_2d(in_arr, out_arr, ii, jj)
-       REAL(dp), INTENT(IN)              ::  in_arr(0:,0:,0:)
-       REAL(dp), INTENT(OUT)             ::  out_arr(0:)
-       INTEGER, INTENT(IN), DIMENSION(:) ::  ii, jj
-
-       INTEGER  ::  i, j, k, l
-       REAL(dp) ::  ni
-
-       IF (SIZE(ii) /= SIZE(jj))  THEN
-          message = "Length of 'ii' and 'jj' index lists do not match." //     &
-             NEW_LINE(' ') // "ii has " // str(SIZE(ii)) // " elements, " //   &
-             NEW_LINE(' ') // "jj has " // str(SIZE(jj)) // "."
-          CALL inifor_abort('average_2d', message)
-       ENDIF
-
-       IF (SIZE(ii) == 0)  THEN
-          message = "No columns to average over; " //                          &
-                    "size of index lists 'ii' and 'jj' is zero."
-          CALL inifor_abort('average_2d', message)
-       ENDIF
-
-       DO k = 0, UBOUND(out_arr, 1)
-
-          out_arr(k) = 0.0_dp
-          DO l = 1, UBOUND(ii, 1)
-             i = ii(l)
-             j = jj(l)
-             out_arr(k) = out_arr(k) + in_arr(i, j, k)
-          ENDDO
-
+ SUBROUTINE average_2d(in_arr, out_arr, ii, jj)
+    REAL(wp), INTENT(IN)              ::  in_arr(0:,0:,0:)
+    REAL(wp), INTENT(OUT)             ::  out_arr(0:)
+    INTEGER, INTENT(IN), DIMENSION(:) ::  ii, jj
+
+    INTEGER  ::  i, j, k, l
+    REAL(wp) ::  ni
+
+    IF (SIZE(ii) /= SIZE(jj))  THEN
+       message = "Length of 'ii' and 'jj' index lists do not match." //     &
+          NEW_LINE(' ') // "ii has " // str(SIZE(ii)) // " elements, " //   &
+          NEW_LINE(' ') // "jj has " // str(SIZE(jj)) // "."
+       CALL inifor_abort('average_2d', message)
+    ENDIF
+
+    IF (SIZE(ii) == 0)  THEN
+       message = "No columns to average over; " //                          &
+                 "size of index lists 'ii' and 'jj' is zero."
+       CALL inifor_abort('average_2d', message)
+    ENDIF
+
+    DO  k = 0, UBOUND(out_arr, 1)
+
+       out_arr(k) = 0.0_wp
+       DO  l = 1, UBOUND(ii, 1)
+          i = ii(l)
+          j = jj(l)
+          out_arr(k) = out_arr(k) + in_arr(i, j, k)
        ENDDO
 
-       ni = 1.0_dp / SIZE(ii)
-       out_arr(:) = out_arr(:) * ni
-
-    END SUBROUTINE average_2d
+    ENDDO
+
+    ni = 1.0_wp / SIZE(ii)
+    out_arr(:) = out_arr(:) * ni
+
+ END SUBROUTINE average_2d
 
 
@@ -320,31 +325,31 @@
 !> as coarse as COSMO, horizontally as fine as PALM).
 !------------------------------------------------------------------------------!
-    SUBROUTINE interpolate_3d(source_array, palm_array, palm_intermediate, palm_grid)
-       TYPE(grid_definition), INTENT(IN) ::  palm_intermediate, palm_grid
-       REAL(dp), DIMENSION(:,:,:), INTENT(IN)  ::  source_array
-       REAL(dp), DIMENSION(:,:,:), INTENT(OUT) ::  palm_array
-       REAL(dp), DIMENSION(:,:,:), ALLOCATABLE ::  intermediate_array
-       INTEGER ::  nx, ny, nlev
-
-       nx = palm_intermediate % nx
-       ny = palm_intermediate % ny
-       nlev = palm_intermediate % nz
-
-!
-!--    Interpolate from COSMO to intermediate grid. Allocating with one
-!--    less point in the vertical, since scalars like T have 50 instead of 51
-!--    points in COSMO.
-       ALLOCATE(intermediate_array(0:nx, 0:ny, 0:nlev-1)) !
-
-       CALL interpolate_2d(source_array, intermediate_array, palm_intermediate)
-
-!
-!--    Interpolate from intermediate grid to palm_grid grid, includes
-!--    extrapolation for cells below COSMO domain.
-       CALL interpolate_1d_arr(intermediate_array, palm_array, palm_grid)
-
-       DEALLOCATE(intermediate_array)
-
-    END SUBROUTINE interpolate_3d
+ SUBROUTINE interpolate_3d(source_array, palm_array, palm_intermediate, palm_grid)
+    TYPE(grid_definition), INTENT(IN) ::  palm_intermediate, palm_grid
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)  ::  source_array
+    REAL(wp), DIMENSION(:,:,:), INTENT(OUT) ::  palm_array
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  intermediate_array
+    INTEGER ::  nx, ny, nlev
+
+    nx = palm_intermediate%nx
+    ny = palm_intermediate%ny
+    nlev = palm_intermediate%nz
+
+!
+!-- Interpolate from COSMO to intermediate grid. Allocating with one
+!-- less point in the vertical, since scalars like T have 50 instead of 51
+!-- points in COSMO.
+    ALLOCATE(intermediate_array(0:nx, 0:ny, 0:nlev-1)) !
+
+    CALL interpolate_2d(source_array, intermediate_array, palm_intermediate)
+
+!
+!-- Interpolate from intermediate grid to palm_grid grid, includes
+!-- extrapolation for cells below COSMO domain.
+    CALL interpolate_1d_arr(intermediate_array, palm_array, palm_grid)
+
+    DEALLOCATE(intermediate_array)
+
+ END SUBROUTINE interpolate_3d
 
 
@@ -355,52 +360,52 @@
 !> averaging grid 'avg_grid' and store the result in 'profile_array'.
 !------------------------------------------------------------------------------!
-    SUBROUTINE interp_average_profile(source_array, profile_array, avg_grid)
-       TYPE(grid_definition), INTENT(IN)          ::  avg_grid
-       REAL(dp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array
-       REAL(dp), DIMENSION(:), INTENT(OUT)        ::  profile_array
-
-       INTEGER ::  i_source, j_source, k_profile, k_source, l, m
-
-       REAL ::  ni_columns
-
-       profile_array(:) = 0.0_dp
-
-       DO l = 1, avg_grid % n_columns
-          i_source = avg_grid % iii(l)
-          j_source = avg_grid % jjj(l)
-
-!
-!--       Loop over PALM levels
-          DO k_profile = avg_grid % k_min, UBOUND(profile_array, 1)
-
-!
-!--          Loop over vertical interpolation neighbours
-             DO m = 1, 2
-
-                k_source = avg_grid % kkk(l, k_profile, m)
-
-                profile_array(k_profile) = profile_array(k_profile)            &
-                   + avg_grid % w(l, k_profile, m)                             &
-                   * source_array(i_source, j_source, k_source)
-!
-!--          Loop over vertical interpolation neighbours m
-             ENDDO
-
-!
-!--       Loop over PALM levels k_profile
+ SUBROUTINE interp_average_profile(source_array, profile_array, avg_grid)
+    TYPE(grid_definition), INTENT(IN)          ::  avg_grid
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array
+    REAL(wp), DIMENSION(:), INTENT(OUT)        ::  profile_array
+
+    INTEGER ::  i_source, j_source, k_profile, k_source, l, m
+
+    REAL ::  ni_columns
+
+    profile_array(:) = 0.0_wp
+
+    DO  l = 1, avg_grid%n_columns
+       i_source = avg_grid%iii(l)
+       j_source = avg_grid%jjj(l)
+
+!
+!--    Loop over PALM levels
+       DO  k_profile = avg_grid%k_min, UBOUND(profile_array, 1)
+
+!
+!--       Loop over vertical interpolation neighbours
+          DO  m = 1, 2
+
+             k_source = avg_grid%kkk(l, k_profile, m)
+
+             profile_array(k_profile) = profile_array(k_profile)            &
+                + avg_grid%w(l, k_profile, m)                             &
+                * source_array(i_source, j_source, k_source)
+!
+!--       Loop over vertical interpolation neighbours m
           ENDDO
 
 !
-!--    Loop over horizontal neighbours l
+!--    Loop over PALM levels k_profile
        ENDDO
 
-       ni_columns = 1.0_dp / avg_grid % n_columns
-       profile_array(:) = profile_array(:) * ni_columns
-
-!
-!--    Constant extrapolation to the bottom
-       profile_array(1:avg_grid % k_min-1) = profile_array(avg_grid % k_min)
-
-    END SUBROUTINE interp_average_profile
+!
+!-- Loop over horizontal neighbours l
+    ENDDO
+
+    ni_columns = 1.0_wp / avg_grid%n_columns
+    profile_array(:) = profile_array(:) * ni_columns
+
+!
+!-- Constant extrapolation to the bottom
+    profile_array(1:avg_grid%k_min-1) = profile_array(avg_grid%k_min)
+
+ END SUBROUTINE interp_average_profile
 
 
@@ -411,40 +416,40 @@
 !> averaging grid 'avg_grid' and store the result in 'profile_array'.
 !------------------------------------------------------------------------------!
-    SUBROUTINE average_profile( source_array, profile_array, avg_grid )
-
-       TYPE(grid_definition), INTENT(IN)          ::  avg_grid
-       REAL(dp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array 
-       REAL(dp), DIMENSION(:), INTENT(OUT)        ::  profile_array
-
-       INTEGER ::  i_source, j_source, l, nz, nlev
-
-       REAL(dp) ::  ni_columns
-
-       nlev = SIZE( source_array, 3 )
-       nz   = SIZE( profile_array, 1 )
-
-       IF ( nlev /= nz )  THEN
-          message = "Lengths of input and output profiles do not match: " //   &
-                    "cosmo_pressure(" // TRIM( str( nlev ) ) //                &
-                    "), profile_array(" // TRIM( str( nz ) )  // ")."
-          CALL inifor_abort('average_pressure_perturbation', message)
-       ENDIF
-      
-       profile_array(:) = 0.0_dp
-
-       DO l = 1, avg_grid % n_columns
-
-          i_source = avg_grid % iii(l)
-          j_source = avg_grid % jjj(l)
-
-          profile_array(:) = profile_array(:)                                  &
-                           + source_array(i_source, j_source, :)
-
-       ENDDO
-
-       ni_columns = 1.0_dp / avg_grid % n_columns
-       profile_array(:) = profile_array(:) * ni_columns
-
-    END SUBROUTINE average_profile
+ SUBROUTINE average_profile( source_array, profile_array, avg_grid )
+
+    TYPE(grid_definition), INTENT(IN)          ::  avg_grid
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array 
+    REAL(wp), DIMENSION(:), INTENT(OUT)        ::  profile_array
+
+    INTEGER ::  i_source, j_source, l, nz, nlev
+
+    REAL(wp) ::  ni_columns
+
+    nlev = SIZE( source_array, 3 )
+    nz   = SIZE( profile_array, 1 )
+
+    IF ( nlev /= nz )  THEN
+       message = "Lengths of input and output profiles do not match: " //   &
+                 "cosmo_pressure(" // TRIM( str( nlev ) ) //                &
+                 "), profile_array(" // TRIM( str( nz ) )  // ")."
+       CALL inifor_abort('average_pressure_perturbation', message)
+    ENDIF
+    
+    profile_array(:) = 0.0_wp
+
+    DO  l = 1, avg_grid%n_columns
+
+       i_source = avg_grid%iii(l)
+       j_source = avg_grid%jjj(l)
+
+       profile_array(:) = profile_array(:)                                  &
+                        + source_array(i_source, j_source, :)
+
+    ENDDO
+
+    ni_columns = 1.0_wp / avg_grid%n_columns
+    profile_array(:) = profile_array(:) * ni_columns
+
+ END SUBROUTINE average_profile
 
 
@@ -456,52 +461,52 @@
 !> averaging.
 !------------------------------------------------------------------------------!
-    SUBROUTINE average_pressure_perturbation( cosmo_pressure, profile_array,   &
-                                              cosmo_grid, avg_grid )
-
-       TYPE(grid_definition), INTENT(IN)          ::  cosmo_grid, avg_grid
-       REAL(dp), DIMENSION(:,:,:), INTENT(IN)     ::  cosmo_pressure
-       REAL(dp), DIMENSION(:), INTENT(OUT)        ::  profile_array
-
-       INTEGER ::  i_source, j_source, l, nz, nlev
-
-       REAL(dp)                            ::  ni_columns
-       REAL(dp), DIMENSION(:), ALLOCATABLE ::  basic_state_pressure
-
-       nlev = SIZE( cosmo_pressure, 3 )
-       nz   = SIZE( profile_array, 1 )
-
-       IF ( nlev /= nz )  THEN
-          message = "Lengths of input and output profiles do not match: " //   &
-                    "cosmo_pressure(" // TRIM( str( nlev ) ) //                &
-                    "), profile_array(" // TRIM( str( nz ) )  // ")."
-          CALL inifor_abort('average_pressure_perturbation', message)
-       ENDIF
-
-       ALLOCATE( basic_state_pressure(nz) )
-       profile_array(:) = 0.0_dp
-
-       DO l = 1, avg_grid % n_columns
-          i_source = avg_grid % iii(l)
-          j_source = avg_grid % jjj(l)
-
-!
-!--       Compute pressure perturbation by removing COSMO basic state pressure
-          CALL get_basic_state( cosmo_grid % hfl(i_source,j_source,:), BETA,   &
-                                P_SL, T_SL, RD, G, basic_state_pressure )
-
-          profile_array(:) = profile_array(:)                                  &
-                           + cosmo_pressure(i_source, j_source, :)             &
-                           - basic_state_pressure(:)
-
-!
-!--    Loop over horizontal neighbours l
-       ENDDO
-
-       DEALLOCATE( basic_state_pressure )
-
-       ni_columns = 1.0_dp / avg_grid % n_columns
-       profile_array(:) = profile_array(:) * ni_columns
-
-    END SUBROUTINE average_pressure_perturbation
+ SUBROUTINE average_pressure_perturbation( cosmo_pressure, profile_array,   &
+                                           cosmo_grid, avg_grid )
+
+    TYPE(grid_definition), INTENT(IN)          ::  cosmo_grid, avg_grid
+    REAL(wp), DIMENSION(:,:,:), INTENT(IN)     ::  cosmo_pressure
+    REAL(wp), DIMENSION(:), INTENT(OUT)        ::  profile_array
+
+    INTEGER ::  i_source, j_source, l, nz, nlev
+
+    REAL(wp)                            ::  ni_columns
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  basic_state_pressure
+
+    nlev = SIZE( cosmo_pressure, 3 )
+    nz   = SIZE( profile_array, 1 )
+
+    IF ( nlev /= nz )  THEN
+       message = "Lengths of input and output profiles do not match: " //   &
+                 "cosmo_pressure(" // TRIM( str( nlev ) ) //                &
+                 "), profile_array(" // TRIM( str( nz ) )  // ")."
+       CALL inifor_abort('average_pressure_perturbation', message)
+    ENDIF
+
+    ALLOCATE( basic_state_pressure(nz) )
+    profile_array(:) = 0.0_wp
+
+    DO  l = 1, avg_grid%n_columns
+       i_source = avg_grid%iii(l)
+       j_source = avg_grid%jjj(l)
+
+!
+!--    Compute pressure perturbation by removing COSMO basic state pressure
+       CALL get_basic_state( cosmo_grid%hfl(i_source,j_source,:), BETA,   &
+                             P_SL, T_SL, RD, G, basic_state_pressure )
+
+       profile_array(:) = profile_array(:)                                  &
+                        + cosmo_pressure(i_source, j_source, :)             &
+                        - basic_state_pressure(:)
+
+!
+!-- Loop over horizontal neighbours l
+    ENDDO
+
+    DEALLOCATE( basic_state_pressure )
+
+    ni_columns = 1.0_wp / avg_grid%n_columns
+    profile_array(:) = profile_array(:) * ni_columns
+
+ END SUBROUTINE average_pressure_perturbation
 
 
@@ -513,20 +518,20 @@
 !> Extrapolates density linearly from the level 'k_min' downwards.
 !------------------------------------------------------------------------------!
-    SUBROUTINE extrapolate_density(rho, avg_grid)
-       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  rho
-       TYPE(grid_definition), INTENT(IN)     ::  avg_grid
-
-       REAL(dp) ::  drhodz, dz, zk, rhok
-       INTEGER  ::  k_min
-
-       k_min  = avg_grid % k_min
-       zk     = avg_grid % z(k_min)
-       rhok   = rho(k_min)
-       dz     = avg_grid % z(k_min + 1) - avg_grid % z(k_min)
-       drhodz = (rho(k_min + 1) - rho(k_min)) / dz
-
-       rho(1:k_min-1) = rhok + drhodz * (avg_grid % z(1:k_min-1) - zk)
-
-    END SUBROUTINE extrapolate_density
+ SUBROUTINE extrapolate_density(rho, avg_grid)
+    REAL(wp), DIMENSION(:), INTENT(INOUT) ::  rho
+    TYPE(grid_definition), INTENT(IN)     ::  avg_grid
+
+    REAL(wp) ::  drhodz, dz, zk, rhok
+    INTEGER  ::  k_min
+
+    k_min  = avg_grid%k_min
+    zk     = avg_grid%z(k_min)
+    rhok   = rho(k_min)
+    dz     = avg_grid%z(k_min + 1) - avg_grid%z(k_min)
+    drhodz = (rho(k_min + 1) - rho(k_min)) / dz
+
+    rho(1:k_min-1) = rhok + drhodz * (avg_grid%z(1:k_min-1) - zk)
+
+ END SUBROUTINE extrapolate_density
 
 
@@ -536,24 +541,24 @@
 !> Driver for extrapolating pressure from PALM level k_min downwards
 !------------------------------------------------------------------------------!
-    SUBROUTINE extrapolate_pressure(p, rho, avg_grid)
-       REAL(dp), DIMENSION(:), INTENT(IN)    ::  rho
-       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  p
-       TYPE(grid_definition), INTENT(IN)     ::  avg_grid
-
-       REAL(dp) ::  drhodz, dz, zk, rhok
-       INTEGER  ::  k, k_min
-
-       k_min = avg_grid % k_min
-       zk    = avg_grid % z(k_min)
-       rhok  = rho(k_min)
-       dz    = avg_grid % z(k_min + 1) - avg_grid % z(k_min)
-       drhodz = 0.5_dp * (rho(k_min + 1) - rho(k_min)) / dz
-
-       DO k = 1, k_min-1
-          p(k) = constant_density_pressure(p(k_min), zk, rhok, drhodz,         &
-                                           avg_grid % z(k), G)
-       ENDDO
-
-    END SUBROUTINE extrapolate_pressure
+ SUBROUTINE extrapolate_pressure(p, rho, avg_grid)
+    REAL(wp), DIMENSION(:), INTENT(IN)    ::  rho
+    REAL(wp), DIMENSION(:), INTENT(INOUT) ::  p
+    TYPE(grid_definition), INTENT(IN)     ::  avg_grid
+
+    REAL(wp) ::  drhodz, dz, zk, rhok
+    INTEGER  ::  k, k_min
+
+    k_min = avg_grid%k_min
+    zk    = avg_grid%z(k_min)
+    rhok  = rho(k_min)
+    dz    = avg_grid%z(k_min + 1) - avg_grid%z(k_min)
+    drhodz = 0.5_wp * (rho(k_min + 1) - rho(k_min)) / dz
+
+    DO  k = 1, k_min-1
+       p(k) = constant_density_pressure(p(k_min), zk, rhok, drhodz,         &
+                                        avg_grid%z(k), G)
+    ENDDO
+
+ END SUBROUTINE extrapolate_pressure
 
 
@@ -564,32 +569,32 @@
 !> extrapolated pressure at the surface.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_surface_pressure(p, rho, avg_grid)
-       REAL(dp), DIMENSION(:), INTENT(IN)    ::  rho
-       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  p
-       TYPE(grid_definition), INTENT(IN)     ::  avg_grid
-
-       REAL(dp) ::  drhodz, dz, zk, rhok
-       INTEGER  ::  k_min
-
-       k_min = avg_grid % k_min
-       zk    = avg_grid % z(k_min)
-       rhok  = rho(k_min)
-       dz    = avg_grid % z(k_min + 1) - avg_grid % z(k_min)
-       drhodz = 0.5_dp * (rho(k_min + 1) - rho(k_min)) / dz
-
-       p(1) = constant_density_pressure(p(k_min), zk, rhok, drhodz,            &
-                                        0.0_dp, G)
-
-    END SUBROUTINE get_surface_pressure
-
-
-    FUNCTION constant_density_pressure(pk, zk, rhok, drhodz, z, g)  RESULT(p)
-
-       REAL(dp), INTENT(IN)  ::  pk, zk, rhok, drhodz, g, z
-       REAL(dp) ::  p
-
-       p = pk + ( zk - z ) * g * ( rhok + 0.5*drhodz * (zk - z) )
-
-    END FUNCTION constant_density_pressure
+ SUBROUTINE get_surface_pressure(p, rho, avg_grid)
+    REAL(wp), DIMENSION(:), INTENT(IN)    ::  rho
+    REAL(wp), DIMENSION(:), INTENT(INOUT) ::  p
+    TYPE(grid_definition), INTENT(IN)     ::  avg_grid
+
+    REAL(wp) ::  drhodz, dz, zk, rhok
+    INTEGER  ::  k_min
+
+    k_min = avg_grid%k_min
+    zk    = avg_grid%z(k_min)
+    rhok  = rho(k_min)
+    dz    = avg_grid%z(k_min + 1) - avg_grid%z(k_min)
+    drhodz = 0.5_wp * (rho(k_min + 1) - rho(k_min)) / dz
+
+    p(1) = constant_density_pressure(p(k_min), zk, rhok, drhodz,            &
+                                     0.0_wp, G)
+
+ END SUBROUTINE get_surface_pressure
+
+
+ FUNCTION constant_density_pressure(pk, zk, rhok, drhodz, z, g)  RESULT(p)
+
+    REAL(wp), INTENT(IN)  ::  pk, zk, rhok, drhodz, g, z
+    REAL(wp) ::  p
+
+    p = pk + ( zk - z ) * g * ( rhok + 0.5*drhodz * (zk - z) )
+
+ END FUNCTION constant_density_pressure
 
 !-----------------------------------------------------------------------------!
@@ -599,15 +604,15 @@
 !> vg.
 !-----------------------------------------------------------------------------!
-    SUBROUTINE geostrophic_winds(p_north, p_south, p_east, p_west, rho, f3,    &
-                                 Lx, Ly, phi_n, lam_n, phi_g, lam_g, ug, vg)
-
-    REAL(dp), DIMENSION(:), INTENT(IN)  ::  p_north, p_south, p_east, p_west,  &
+ SUBROUTINE geostrophic_winds(p_north, p_south, p_east, p_west, rho, f3,    &
+                              Lx, Ly, phi_n, lam_n, phi_g, lam_g, ug, vg)
+
+    REAL(wp), DIMENSION(:), INTENT(IN)  ::  p_north, p_south, p_east, p_west,  &
                                             rho
-    REAL(dp), INTENT(IN)                ::  f3, Lx, Ly, phi_n, lam_n, phi_g, lam_g
-    REAL(dp), DIMENSION(:), INTENT(OUT) ::  ug, vg
-    REAL(dp)                            ::  facx, facy
-
-    facx = 1.0_dp / (Lx * f3)
-    facy = 1.0_dp / (Ly * f3)
+    REAL(wp), INTENT(IN)                ::  f3, Lx, Ly, phi_n, lam_n, phi_g, lam_g
+    REAL(wp), DIMENSION(:), INTENT(OUT) ::  ug, vg
+    REAL(wp)                            ::  facx, facy
+
+    facx = 1.0_wp / (Lx * f3)
+    facy = 1.0_wp / (Ly * f3)
     ug(:) = - facy / rho(:) * (p_north(:) - p_south(:))
     vg(:) =   facx / rho(:) * (p_east(:) - p_west(:))
@@ -617,5 +622,5 @@
     )
 
-    END SUBROUTINE geostrophic_winds
+ END SUBROUTINE geostrophic_winds
 
 
@@ -627,18 +632,18 @@
 !> lngitude of a geographical system centered at x0 and y0.
 !-----------------------------------------------------------------------------!
-    SUBROUTINE inv_plate_carree(x, y, x0, y0, r, lat, lon)
-       REAL(dp), INTENT(IN)  ::  x(:), y(:), x0, y0, r
-       REAL(dp), INTENT(OUT) ::  lat(:), lon(:)
-       
-       REAL(dp) :: ri
-
-!
-!--    TODO check dimensions of lat/lon and y/x match
-
-       ri = 1.0_dp / r
-       
-       lat(:) = (y(:) - y0) * ri
-       lon(:) = (x(:) - x0) * ri
-    END SUBROUTINE 
+ SUBROUTINE inv_plate_carree(x, y, x0, y0, r, lat, lon)
+    REAL(wp), INTENT(IN)  ::  x(:), y(:), x0, y0, r
+    REAL(wp), INTENT(OUT) ::  lat(:), lon(:)
+    
+    REAL(wp) :: ri
+
+!
+!-- TODO check dimensions of lat/lon and y/x match
+
+    ri = 1.0_wp / r
+    
+    lat(:) = (y(:) - y0) * ri
+    lon(:) = (x(:) - x0) * ri
+ END SUBROUTINE 
 
 
